<?php
if (!empty($_SERVER)) {
 $document_root = $_SERVER['DOCUMENT_ROOT'];
 $script_name = $_SERVER['SCRIPT_NAME'];
 $server_addr = $_SERVER['SERVER_ADDR'];
 $http_host = $_SERVER['HTTP_HOST'];
} else {
 $document_root = getenv('DOCUMENT_ROOT');
 $script_name = getenv('SCRIPT_NAME');
 $server_addr = getenv('SERVER_ADDR');
 $http_host = getenv('HTTP_HOST');
}

$rep = $document_root.$script_name;
$rep = substr($rep,0,strrpos($rep,'/'));
while (!file_exists($rep.'/config.inc.php')) {
 if ($rep == '') { break; }
 $rep = substr($rep,0,strrpos($rep,'/'));
}
if ($rep != '')
include $rep.'/config.inc.php';

$proutdns_version = '0.6.2';
$proutdns_name = 'ProutDNS v'.$proutdns_version;
$proutdns_url = 'http://www.prout.be/ProutDNS/';

if ($service_name == '') {
 $service_name = $proutdns_name;
 $title = $proutdns_name;
} else {
 $title = "$service_name :: $proutdns_name";
}

$urlip = $server_addr;

$path = $script_name;
$path = substr($path,0,strrpos($path,'/'));

$urlupdate = 'http://'.$http_host.$path.'/upd.php?user=<font color="#ff9400">USER</font>&amp;pwd=<font color="#ff9400">PASS</font>&amp;host=<font color="#ff9400">HOST1,HOST2</font>';
$urlupdatekey = 'http://'.$http_host.$path.'/upd.php?key=<font color="#ff9400">KEY</font>&amp;host=<font color="#ff9400">HOST1,HOST2</font>';

if (trim($dt_format) == '') { $dt_format = 'Y/m/d H:i'; }

if (!defined('PRD_PHP_INT_VERSION')) {
    if (!ereg('([0-9]{1,2}).([0-9]{1,2}).([0-9]{1,2})', phpversion(), $match)) {
        $result = ereg('([0-9]{1,2}).([0-9]{1,2})', phpversion(), $match);
    }
    if (isset($match) && !empty($match[1])) {   
        if (!isset($match[2])) {
            $match[2] = 0;
        }
        if (!isset($match[3])) {
            $match[3] = 0;
        }
        define('PRD_PHP_INT_VERSION', (int)sprintf('%d%02d%02d', $match[1], $match[2], $match[3]));
        unset($match);
    } else {
        define('PRD_PHP_INT_VERSION', 0);
    }
}

## FUNCS ##

# Magic quotes for incoming GET/POST/Cookie data.
# DEFAULT; magic_quotes_gpc = On
# Magic quotes for runtime-generated data, e.g. data from SQL, from exec(), etc.
# DEFAULT; magic_quotes_runtime = Off

function oui_slashes_gpc ($string) {
 if (get_magic_quotes_gpc()) {
  return $string;
 } else {
  return addslashes($string);
 }
}

function non_slashes_gpc ($string) {       
 if (get_magic_quotes_gpc()) {
  return stripslashes($string);
 } else {
  return $string;
 }
}

function non_slashes_mysql ($string) {
 if (get_magic_quotes_runtime()) {
  return stripslashes($string);
 } else {
  return $string;
 }
}

function oui_slashes_mysql ($string) {
 if (get_magic_quotes_runtime()) {
  return $string;   
 } else {
  return addslashes($string);
 }
}

function sortdomains ($a,$b) {
 global $CBD;
 
 $a = $a['domain'];
 $b = $b['domain'];
 while (substr($a,-1,1) == substr($b,-1,1)) {
  $a = substr($a,0,-1);
  $b = substr($b,0,-1);
 }
 if ($a == '') {
  return false;
 } elseif ($b == '') {
  return true;
 } else {
  if (!strpos($a,'.') === false) {
   $a = substr($a,strrpos($a,'.')+1);
  }
  if (!strpos($b,'.') === false) {
   $b = substr($b,strrpos($b,'.')+1);
  }
  return strcmp($a,$b);
 }
}

function GiveDomainsList ($id_domain = '') {
global $CBD;
 $RS_query = mysql_query(("SELECT `id_domain`,`domain` FROM `domains` WHERE (`enable_a`=1 OR `enable_ns`=1 OR `enable_url`=1) AND `domain`<>'' AND `dnsip`<>''"),$CBD);
 $list = '';
 $all = array();
 if ($RS_query) {
 while ($RS = mysql_fetch_array($RS_query)) {
  array_walk($RS,'non_slashes_mysql');
  array_push($all,$RS);
 }
 usort ($all, 'sortdomains');
 for ($i=0 ; $i < count($all) ; $i++) {
  $RS = $all[$i];
  if ($RS['id_domain'] == $id_domain) {
  $list .= '<option value="'.htmlspecialchars($RS['id_domain']).'" selected>'.$RS['domain'].'</option>';
  } else {
  $list .= '<option value="'.htmlspecialchars($RS['id_domain']).'">'.$RS['domain'].'</option>';
  }
 }
 if ($list != '') {
 return '<select name="id_domain">'.$list.'</select>';
 } else {
 return false;
 }
 } else {
 return false;
 }
}

function GiveDomainsExmp () {
global $CBD;
 $RS_query = mysql_query(("SELECT `domain` FROM `domains` WHERE (`enable_a`=1 OR `enable_ns`=1 OR `enable_url`=1) AND `domain`<>'' AND `dnsip`<>''"),$CBD);
 $all = array();
 if ($RS_query) {
 while ($RS = mysql_fetch_array($RS_query)) {
  array_walk($RS,'non_slashes_mysql');
  array_push($all,$RS);
 }
 usort ($all, 'sortdomains');
 if (array_key_exists(0,$all)) {
  $RS = $all[0];
  $exmp = $RS['domain'];
  if ($exmp != '') {
  return $exmp;
  } else {
  return false;
  }
 } else {
 return false;
 }
 } else {
 return false;
 }
} 

function GiveDomainsFList () {
global $CBD;
 $RS_query = mysql_query(("SELECT `domain` FROM `domains` WHERE (`enable_a`=1 OR `enable_ns`=1 OR `enable_url`=1) AND `domain`<>'' AND `dnsip`<>''"),$CBD);
 $list = '';
 $all = array();
 if ($RS_query) {
 while ($RS = mysql_fetch_array($RS_query)) {
  array_walk($RS,'non_slashes_mysql');
  array_push($all,$RS);
 }
 usort ($all, 'sortdomains');
 for ($i=0 ; $i < count($all) ; $i++) {
  $RS = $all[$i];
  $list .= $RS['domain'].', ';
 }
 if ($list != '') {
 return substr($list,0,-2);
 } else {
 return false;
 }
 } else {
 return false;
 }
}

function validate_ip ($ip) {
 if (is_string($ip) && ereg('^([0-9]{1,3})\.([0-9]{1,3})\.'.'([0-9]{1,3})\.([0-9]{1,3})$',$ip,$part)) {
  if ($part[1] <= 255 && $part[2] <= 255 && $part[3] <= 255 && $part[4] <= 255)
  return true;
 }
 return false;
}

function getMyIP () {
 if (!empty($_SERVER)) {
  if (array_key_exists('HTTP_X_FORWARDED_FOR', $_SERVER) && $_SERVER['HTTP_X_FORWARDED_FOR'] != '') {
   $remote_addr = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } else {
   $remote_addr = $_SERVER['REMOTE_ADDR'];
  }
 } else {
  if (getenv('HTTP_X_FORWARDED_FOR') != '') {
   $remote_addr = getenv('HTTP_X_FORWARDED_FOR');
  } else {
   $remote_addr = getenv('REMOTE_ADDR');
  }
 }
 return $remote_addr;
}
?>
