<?php
if (!empty($_SERVER)) {
 $document_root = $_SERVER['DOCUMENT_ROOT'];
 $script_name = $_SERVER['SCRIPT_NAME'];
} else {
 $document_root = getenv('DOCUMENT_ROOT');
 $script_name = getenv('SCRIPT_NAME');
}

$rep = $document_root.$script_name;
$rep = substr($rep,0,strrpos($rep,'/'));
while (!file_exists($rep.'/config.inc.php')) {
 if ($rep == '') { break; }
 $rep = substr($rep,0,strrpos($rep,'/'));
}
if ($rep != '')
require_once $rep.'/inc/main.inc.php';

function dns_update ($id_domain,$mydata) {
 global $nsupdate;
 
 if (domain_exists($id_domain)) {
  $infos = domain_infos($id_domain);
  $domain = $infos['domain'];
  $dnsip = $infos['dnsip'];
  $key = $infos['key'];
  if ($key != '') { $add = ' -y '.$key; }
  $data = "server $dnsip\n";
  $data .= "zone $domain\n";
  $data .= $mydata;
  $data .= "\n";
  $result = `echo -e "$data" | $nsupdate$add`;
  return $result;
 } else {
  return false;
 }
}

function dns_delete ($id_domain,$sub) {
 global $CBD,$id_user;
 
 if (domain_exists($id_domain) && $sub != '' && user_exists($id_user)) {
  $infos = domain_infos($id_domain);
  $domain = $infos['domain'];
  
  $data = "update delete ".$sub.".".$domain.". A\n";
  $data .= "update delete ".$sub.".".$domain.". MX\n";
  $data .= "update delete *.".$sub.".".$domain.". CNAME\n";
  $data .= "update delete ns.".$sub.".".$domain.". A\n";
  $data .= "update delete mx.".$sub.".".$domain.". A\n";
  $data .= "update delete ".$sub.".".$domain.". NS\n";
  
  return dns_update($id_domain,$data);
 } else {
  return false;
 }
}

function user_vhostscount ($id_user) {
 global $CBD;
 
 if (user_exists($id_user)) {
  $RS_query = mysql_query(("SELECT COUNT(*) FROM `vhosts` WHERE `id_user`=".addslashes($id_user).";"),$CBD);
  return mysql_result($RS_query,0);
 } else {
  return false;
 }
}

function user_maycreatevhost ($id_user) {
 global $max_vhosts, $CBD;
 
 if (user_exists($id_user)) {
  $max = $max_vhosts;
  if ($max < 0) { $max = 5; }
  if (!is_int($max)) { $max = 5; }
  $infos = user_infos($id_user);
  if ($infos['max'] == -1) {
   return true;
  } elseif ($infos['max'] >= 0) {
   $max = $infos['max'];
  }
  if (user_vhostscount($id_user)+1 > $max) {
   return false;
  } else {
   return true;
  }
 } else {
  return false;
 }
}

function user_lastupdate ($id_user) {
 global $CBD;
  
 if (user_exists($id_user)) {
  $RS_query = mysql_query(("SELECT `moddate` FROM `vhosts` WHERE `id_user`=".addslashes($id_user)." ORDER BY `moddate` DESC;"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   $RS = mysql_fetch_array($RS_query);
   array_walk($RS,'non_slashes_mysql');
   return $RS['moddate'];
  } else {
   return false;
  }
 } else {
  return false; 
 }
}

function user_exists ($id_user) {
 global $CBD;
 
 if (trim($id_user) != '') {
  $RS_query = mysql_query(("SELECT * FROM `users` WHERE `id_user`=".addslashes($id_user).";"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   return true;
  } else {
   return false;  
  }
 } else {
  return false;
 }
}

function user_findid ($username,$return_id = true) {
 global $CBD;
  
 if (trim($username) != '') {
 $RS_query = mysql_query(("SELECT * FROM `users` WHERE `username`='".addslashes($username)."';"),$CBD);
 if (mysql_numrows($RS_query) != 0) {
  $RS = mysql_fetch_array($RS_query);
  array_walk($RS,'non_slashes_mysql');
  if ($return_id) {
   return $RS['id_user'];
  } else {  
   return true; 
  } 
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function user_infos ($id_user) {
 global $CBD;
 
 if (user_exists($id_user)) {
 $RS_query = mysql_query(("SELECT * FROM `users` WHERE `id_user`=".addslashes($id_user).";"),$CBD);
 if (mysql_numrows($RS_query) != 0) { 
  $infos = mysql_fetch_array($RS_query);
  array_walk($infos,'non_slashes_mysql');
  return $infos;
 } else {
  return false;
 } 
 } else {
  return false;
 }
}

function mykey_make($id_user) {
 if (user_exists($id_user)) {
  $infos = user_infos($id_user);
  return mykey_generate($infos['username']);
 } else {
  return false;
 }
}

function mykey_generate($name) {
 return md5($name.time());
}

function mykey_exists ($key) {
 global $CBD;
 
 if (trim($key) != '') {
  $RS_query = mysql_query(("SELECT * FROM `users` WHERE `key`='".addslashes($key)."';"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   return true;
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function mykey_give ($key) {
 global $CBD;
  
 if (trim($key) != '') {
  $RS_query = mysql_query(("SELECT * FROM `users` WHERE `key`='".addslashes($key)."';"),$CBD);                  
  if (mysql_numrows($RS_query) != 0) {
   $RS = mysql_fetch_array($RS_query);
   array_walk($RS,'non_slashes_mysql');
   return $RS['id_user'];
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function domain_vhostscount ($id_domain) {
 global $CBD;
 
 if (domain_exists($id_domain)) {
  $RS_query = mysql_query(("SELECT COUNT(*) FROM `vhosts` WHERE `id_domain`=".addslashes($id_domain).";"),$CBD);
  return mysql_result($RS_query,0);
 } else {
  return false;
 }
}

function domain_maycreatevhost ($id_domain) {
 global $CBD;
 
 if (domain_exists($id_domain)) {
  $infos = domain_infos($id_domain);
  if ($infos['max'] == -1) {
   return true;
  } elseif ($infos['max'] >= 0) {
   $max = $infos['max'];
  } else {
   return true;
  }
  if (domain_vhostscount($id_domain)+1 > $max) {
   return false;
  } else {
   return true;
  }
 } else {
  return false;
 }
}

function domain_exists ($id_domain) {
 global $CBD;
 
 if (trim($id_domain) != '') {
  $RS_query = mysql_query(("SELECT * FROM `domains` WHERE `id_domain`=".addslashes($id_domain)." AND `domain`<>'' AND `dnsip`<>'';"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   $infos = mysql_fetch_array($RS_query);
   array_walk($infos,'non_slashes_mysql');
   if ($infos['enable_a'] == 0 && $infos['enable_ns'] == 0 && $infos['enable_url'] == 0) {
    return false;
   } else {
    return true;
   }
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function domain_findid ($domain,$return_id = true) {
 global $CBD;

 if (trim($domain) != '') {
 $RS_query = mysql_query(("SELECT * FROM `domains` WHERE `domain`='".addslashes($domain)."';"),$CBD);
 if (mysql_numrows($RS_query) != 0) {
  $infos = mysql_fetch_array($RS_query);
  array_walk($infos,'non_slashes_mysql');
  if ($infos['enable_a'] == 0 && $infos['enable_ns'] == 0 && $infos['enable_url'] == 0) {
   return false;
  } else {
   if ($return_id) {
    return $infos['id_domain'];
   } else {
    return true;
   }
  }
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function domain_infos ($id_domain) {
 global $CBD;
 
 if (trim($id_domain) != '') {
  $RS_query = mysql_query(("SELECT * FROM `domains` WHERE `id_domain`=".addslashes($id_domain).";"),$CBD);
  if (mysql_numrows($RS_query) != 0) {   
   $infos = mysql_fetch_array($RS_query);
   array_walk($infos,'non_slashes_mysql');
   return $infos;
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function domain_mode_list ($id_domain,$mode = false) {
 if (domain_exists($id_domain)) {
  $infos = domain_infos($id_domain);
  $list = '';
  if ($infos['enable_a'] == 1) {
   if ($mode == 1) {
   $list .= '<option value="1" selected>A</option>';
   } else {
   $list .= '<option value="1">A</option>';
   }
  }
  if ($infos['enable_ns'] == 1) {
   if ($mode == 2) {
   $list .= '<option value="2" selected>NS</option>'; 
   } else {
   $list .= '<option value="2">NS</option>';
   }
  }
  if ($infos['enable_url'] == 1) {
   if ($mode == 3) {
   $list .= '<option value="3" selected>URL</option>';
   } else {
   $list .= '<option value="3">URL</option>';
   }
  }
  if ($list != '') {
  return '<select name="mode">'.$list.'</select>';
  } else {
  return false;
  }
 } else {
  return false;
 }
}

function vhost_valid ($sub) {
 if (!ereg("^[a-z0-9]+$",$sub)) {
  return false;
 } else {
  return true;
 }
}

function vhost_exists ($id_vhost) {
 global $CBD,$id_user;
 
 if ($id_vhost != '' && user_exists($id_user)) {
  $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_user`=".addslashes($id_user)." AND `id_vhost`=".addslashes($id_vhost).";"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   return true;
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function vhost_uniq ($id_domain,$sub) {
 global $CBD;
 
 if (domain_exists($id_domain) && $sub != '') {
  $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_domain`=".addslashes($id_domain)." AND `sub`='".addslashes($sub)."';"),$CBD);
  if (mysql_numrows($RS_query) != 0) {
   return true;
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function vhost_exclude ($id_domain,$sub) {
 global $CBD;
 $exclude = false;
 
 if (domain_exists($id_domain) && $sub != '') {
  $infos = domain_infos($id_domain);
  $domain = $infos['domain'];
  $exclude_list = $infos['exclude'];
  $exclude_array = array();
  $exclude_array_tmp = explode(',',$exclude_list);
  for ($i=0 ; $i < count($exclude_array_tmp) ; $i++) {
   $already_in = false;
   for ($j=0 ; $j < count($exclude_array) ; $j++) {
    if (strtolower(trim($exclude_array_tmp[$i])) == $exclude_array[$j]) {
     $already_in = true;
     break;
    }
   }
   if (!$already_in) {
   array_push ($exclude_array, strtolower(trim($exclude_array_tmp[$i])));
   }
  }
  $RS_query = mysql_query(("SELECT `domain` FROM `domains` ORDER BY `domain`"),$CBD);
  while ($RS = mysql_fetch_array($RS_query)) {
   array_walk($RS,'non_slashes_mysql');
   $end = '.'.$domain;
   if (substr($RS['domain'],strlen($RS['domain']) - strlen($end)) == $end) {
    $excl = substr($RS['domain'],0,strlen($RS['domain']) - strlen($end));
    array_push ($exclude_array, $excl);
   }
  }
  for ($i=0 ; $i < count($exclude_array) ; $i++) {
   if ($exclude_array[$i] == strtolower(trim($sub))) {
    $exclude = true;
    break;
   }
  }
  if ($exclude) {
   return true;
  } else {
   return false;
  }
 } else {
  return false; // Not exclude but doesnt exist
 }
}

function vhost_findid ($id_domain,$sub,$return_id = true) {
 global $CBD,$id_user;
 
 if (domain_exists($id_domain) && $sub != '' && user_exists($id_user)) {
 $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_user`=".addslashes($id_user)." AND `id_domain`=".addslashes($id_domain)." AND `sub`='".addslashes($sub)."';"),$CBD);
 if (mysql_numrows($RS_query) != 0) {
  $RS = mysql_fetch_array($RS_query);
  array_walk($RS,'non_slashes_mysql');
  if ($return_id) {
   return $RS['id_vhost'];
  } else {
   return true;
  }
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function vhost_infos ($id_vhost) {
 global $CBD;
 
 if (vhost_exists($id_vhost)) {
 $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_vhost`=".addslashes($id_vhost).";"),$CBD);
 if (mysql_numrows($RS_query) != 0) {
  $infos = mysql_fetch_array($RS_query);   
  array_walk($infos,'non_slashes_mysql');
  return $infos;
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function vhost_create ($id_domain,$sub,$mode,$addr,$url,$mx = false,$mxip = '',$wild = true,$cloak = false) {
 global $CBD,$id_user,$ttl,$urlip;
 
 if (user_exists($id_user)) {
 if (user_maycreatevhost($id_user)) {
 if (domain_maycreatevhost($id_domain)) {
  if (domain_exists($id_domain)) {
  if (!vhost_exclude($id_domain,$sub)) {
  if (!vhost_uniq($id_domain,$sub)) {
   if (vhost_valid($sub)) {
    if ($mode == 2) { $mx = false; $wild = false; }
    if ($mode != 3) { $cloak = false; }
    if ($mx && validate_ip($mxip) == false) {
     if (!validate_ip(gethostbyname($mxip)))
     $mx = false;
    }
    if (!$mx) { $mxip = ''; }
    if ($mx) { $mxv = 1; } else { $mxv = 0; }
    if ($wild) { $wildv = 1; } else { $wildv = 0; }
    if ($cloak) { $cloakv = 1; } else { $cloakv = 0; }
    $infos = domain_infos($id_domain);
     $enable_a = $infos['enable_a'];
     $enable_ns = $infos['enable_ns'];
     $enable_url = $infos['enable_url'];
    if ($mode == 1 && $enable_a == 0) {
     return false;
    } elseif ($mode == 2 && $enable_ns == 0) {
     return false;
    } elseif ($mode == 3 && $enable_url == 0) {
     return false;
    }
    if ($mode == 1) {
     if (!validate_ip($addr)) {
      if (validate_ip(gethostbyname($addr)))
      $addr = gethostbyname($addr);
      else
      return false;
     }
    } elseif ($mode == 2) {
     if (!validate_ip($addr)) {
      if (!validate_ip(gethostbyname($addr)))
      return false;
     }
    }
    $SQLq = "INSERT INTO `vhosts` (`id_user`, `id_domain`, `regdate`, `moddate`, `sub`, `mode`, `addr`, `url`, `mx`, `mxip`, `wildcard`, `cloaked`) VALUES (".addslashes($id_user).", ".addslashes($id_domain).", ".time().", ".time().", '".addslashes($sub)."', ".addslashes($mode).", '".addslashes($addr)."', '".addslashes($url)."', ".addslashes($mxv).", '".addslashes($mxip)."', ".addslashes($wildv).", ".addslashes($cloakv).");";
    $RS_query = mysql_query(($SQLq),$CBD);
    if ($RS_query) {
     $domain = $infos['domain'];
     if ($mode == 1) {
      $data = "update add ".$sub.".".$domain.". ".$ttl." IN A ".$addr."\n";
     } elseif ($mode == 2) {
// Note : mettre 86400 comme TTL sur les NS
      if (validate_ip($addr)) {
      $data = "update add ".$sub.".".$domain.". ".$ttl." IN NS ns.".$sub.".".$domain.".\n";
      $data .= "update add ns.".$sub.".".$domain.". ".$ttl." IN A ".$addr."\n";
      } else {
      $data = "update add ".$sub.".".$domain.". ".$ttl." IN NS ".$addr.".\n";
      }
     } elseif ($mode == 3) {
      $data = "update add ".$sub.".".$domain.". ".$ttl." IN A ".$urlip."\n";
     }
     if ($mode == 1 || $mode == 3) {
      if ($mx) {
       if (validate_ip($mxip)) {
       $data .= "update add ".$sub.".".$domain.". ".$ttl." IN MX 10 mx.".$sub.".".$domain.".\n";
       $data .= "update add mx.".$sub.".".$domain.". ".$ttl." IN A ".$mxip."\n";
       } else {
       $data .= "update add ".$sub.".".$domain.". ".$ttl." IN MX 10 ".$mxip.".\n";
       }
      }
      if ($wild) {
       $data .= "update add *.".$sub.".".$domain.". ".$ttl." IN CNAME ".$sub.".".$domain.".\n";
      }
     }
     dns_update($id_domain,$data);
     return vhost_findid($id_domain,$sub);
    } else {
     return false;
    }
   } else {
    return false;
   }
  } else {
   return false;
  }
  } else {
   return false;
  }
  } else {
   return false;
  }
 } else {
  return false;
 }
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function vhost_modif ($id_vhost,$mode,$addr,$url,$mx = false,$mxip = '',$wild = true,$cloak = false) {
 global $CBD,$id_user,$ttl,$urlip;
 
 if (user_exists($id_user)) {
 if (vhost_exists($id_vhost)) {
  if ($mode == 2) { $mx = false; $wild = false; }
  if ($mode != 3) { $cloak = false; }
  if ($mx && validate_ip($mxip) == false) {
   if (!validate_ip(gethostbyname($mxip)))
   $mx = false;
  }
  if (!$mx) { $mxip = ''; }
  if ($mx) { $mxv = 1; } else { $mxv = 0; }
  if ($wild) { $wildv = 1; } else { $wildv = 0; }
  if ($cloak) { $cloakv = 1; } else { $cloakv = 0; }
  $infos = vhost_infos($id_vhost);
   $id_domain = $infos['id_domain'];
   $sub = $infos['sub'];
  
  $infos = domain_infos($id_domain);
   $domain = $infos['domain'];
   $enable_a = $infos['enable_a'];
   $enable_ns = $infos['enable_ns'];
   $enable_url = $infos['enable_url'];
  if ($mode == 1 && $enable_a == 0) {
   return false;
  } elseif ($mode == 2 && $enable_ns == 0) {
   return false;
  } elseif ($mode == 3 && $enable_url == 0) {
   return false;
  }
  if ($mode == 1) {
   if (!validate_ip($addr)) {
    if (validate_ip(gethostbyname($addr)))
    $addr = gethostbyname($addr);
    else
    return false;
   }
  } elseif ($mode == 2) {
   if (!validate_ip($addr)) {
    if (!validate_ip(gethostbyname($addr)))
    return false;
   }
  }
  $SQLq = "UPDATE `vhosts` SET `moddate`=".time().", `mode`=".addslashes($mode).", `addr`='".addslashes($addr)."', `url`='".addslashes($url)."', `mx`=".addslashes($mxv).", `mxip`='".addslashes($mxip)."', `wildcard`=".addslashes($wildv).", `cloaked`=".addslashes($cloakv)." WHERE `id_vhost`=".addslashes($id_vhost).";";
  $RS_query = mysql_query(($SQLq),$CBD);
  if ($RS_query) {
   $data = "update delete ".$sub.".".$domain.". A\n";
   $data .= "update delete ".$sub.".".$domain.". MX\n";
   $data .= "update delete *.".$sub.".".$domain.". CNAME\n";
   $data .= "update delete ns.".$sub.".".$domain.". A\n";
   $data .= "update delete mx.".$sub.".".$domain.". A\n";
   $data .= "update delete ".$sub.".".$domain.". NS\n";
   if ($mode == 1) {
    $data .= "update add ".$sub.".".$domain.". ".$ttl." IN A ".$addr."\n";
   } elseif ($mode == 2) {
    if (validate_ip($addr)) {
    $data .= "update add ".$sub.".".$domain.". ".$ttl." IN NS ns.".$sub.".".$domain.".\n";
    $data .= "update add ns.".$sub.".".$domain.". ".$ttl." IN A ".$addr."\n";
    } else {
    $data .= "update add ".$sub.".".$domain.". ".$ttl." IN NS ".$addr.".\n";
    }
   } elseif ($mode == 3) {
    $data .= "update add ".$sub.".".$domain.". ".$ttl." IN A ".$urlip."\n";
   }
   if ($mode == 1 || $mode == 3) {
    if ($mx) {
     if (validate_ip($mxip)) {
     $data .= "update add ".$sub.".".$domain.". ".$ttl." IN MX 10 mx.".$sub.".".$domain.".\n";
     $data .= "update add mx.".$sub.".".$domain.". ".$ttl." IN A ".$mxip."\n";
     } else {
     $data .= "update add ".$sub.".".$domain.". ".$ttl." IN MX 10 ".$mxip.".\n";
     }
    }
    if ($wild) {
     $data .= "update add *.".$sub.".".$domain.". ".$ttl." IN CNAME ".$sub.".".$domain.".\n";
    }
   }
   dns_update($id_domain,$data);
   return true;
  } else {
   return false;
  }
 } else {
  return false;
 }
 } else {
  return false;
 }
}

function vhost_delete ($id_vhost) {
 global $CBD,$id_user;
 
 if (user_exists($id_user)) {
  if (vhost_exists($id_vhost)) {
   $infos = vhost_infos($id_vhost);
   $id_domain = $infos['id_domain'];
   $sub = $infos['sub'];
   $RS_query = mysql_query(("DELETE FROM `vhosts` WHERE `id_vhost`=".addslashes($id_vhost).";"),$CBD);
   if ($RS_query) {
    dns_delete($id_domain,$sub);
    $RS_query = mysql_query(("OPTIMIZE TABLE `vhosts`;"),$CBD);
    return true;
   } else {
    return false;
   }
  } else {
   return false;
  }
 } else {
  return false;
 }
}
?>
